version: "3"
services:
  app:
    container_name: full_app
    working_dir: /usr/src/app/
    image: cosmtrek/air
    ports:
      - 8090:8090
    restart: on-failure
    env_file: ./.env
    volumes:
      - ./:/usr/src/app/
    depends_on:
      - fullstack-postgres
    networks:
      - fullstack
  
  fullstack-postgres:
    image: postgres:latest
    container_name: full_db_postgres
    environment:
      - POSTGRES_USER=${DB_USER}
      - POSTGRES_PASSWORD=${DB_PASSWORD}
      - POSTGRES_DB=${DB_NAME}
      - DATABASE_HOST=${DB_HOST}
    ports:
      - "5432:5432"
    volumes:
      - database_postgres:/var/lib/postgresql/data
    networks:
      - fullstack

  pgadmin:
    image: dpage/pgadmin4
    container_name: pgadmin_container
    environment:
      PGADMIN_DEFAULT_EMAIL: ${PGADMIN_DEFAULT_EMAIL}
      PGADMIN_DEFAULT_PASSWORD: ${PGADMIN_DEFAULT_PASSWORD}
    depends_on:
      - fullstack-postgres
    ports:
      - "5050:80"
    networks:
      - fullstack
    restart: unless-stopped

volumes:
  api:
  database_postgres:

# Networks to be created to facilitate communication between containers
networks:
  fullstack:
    driver: bridge